#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

string random_correct(int n) {
    if (n == 0) {
        return "";
    }
    string s = string(n / 2, '(') + string(n / 2, ')');
    shuffle(s.begin(), s.end());
    int bal = 0, min_bal = 0, pos = 0;
    for (int i = 0; i < n; i++) {
        bal += (s[i] == '(' ? 1 : -1);
        if (bal < min_bal) {
            min_bal = bal;
            pos = i + 1;
        }
    }
    s = (s + s).substr(pos, n);
    return s;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);                 // number of brackets
    string type = string(argv[2]); // type of sequence: random, random-correct
                                                                 // ladder (((()))), teeth ()()()()(), custom

    ensure(type == "random" || type == "ladder" || type == "teeth" ||
                 type == "random-correct" || type == "custom");

    string s;
    if (type != "custom") {
        for (int i = 0; i < n; i++) {
            if (type == "random") {
                s.push_back(rnd.next(2) ? '(' : ')');
            } else if (type == "ladder") {
                s.push_back(i * 2 < n - 1 ? '(' : ')');
            } else if (type == "teeth" || type == "random-correct") {
                s.push_back(i % 2 == 0 ? '(' : ')');
            }
        }
        if (type == "random-correct") {
            shuffle(s.begin(), s.end());
        }
    } else {
        int m = atoi(argv[3]); // number of bal = 0
        int k = atoi(argv[4]); // number of bal = 1
        vector<int> sizes(m - 1, 1);
        for (int i = m; i <= k; i++) {
            sizes[rnd.next(m - 1)]++;
        }
        vector<int> exp;
        for (int i = 0; i < m - 1; i++) {
            if (sizes[i] > 1)
                exp.push_back(i);
        }
        vector<int> exp_sizes(m - 1, 0);
        for (int i = k * 2; i < n; i += 2) {
            exp_sizes[exp[rnd.next(exp.size())]]+=2;
        }
        for (int j = 0; j < sizes.size(); ++j) {
            int e = sizes[j];
            s += '(';
            int pos = -1;
            if (e > 1)
                pos = 1 + rnd.next(e - 1);
            for (int i = 1; i < e; ++i) {
                s += '(';
                if (i == pos) {
                    s += random_correct(exp_sizes[j]);
                }
                s += ')';
            }
            s += ')';
        }
    }
    n = s.size();
    s = (s + s).substr(rnd.next(n), n);
    cout << n << endl << s << endl;
}
